# AP2000
#
# Script for AP Invoice Batch grid.  
# Adds the Entered by to the batch list
# Adds the two optional fields into the AP Invoice entry grid. 
# You can drag & drop them to the left hand side of the grid if required.
###################################################################################################################################################
# Copyright 2023chid Systems 
# -----------------------------
# Permitted for use with Orchid Systems Modules only.
# The code is supplied on an "as is" basis for training and demonstration purposes only and is not supported by Orchid Systems.
# If this code is deployed in a live production environment it is the responsibility of the End User to ensure 
# that it is operating as required.
###################################################################################################################################################

from accpac import *
from APInvoice import APInvoice

apinv = None

def main(args):
	MyUI()

class MyUI(UI):
	def __init__(self):
		UI.__init__(self)
		self.createScreen()

	def createScreen(self):
		global apinv
		
		if apinv == None:
			apinv = APInvoice()
			
		grid = self.getHostControl("lstAPIBC")
		self.grid = grid
		
		col = UIGridColumn()
		col.caption = "Entered By"
		col.hasFinder = True
		col.isEditable = True
		grid.addColumn(col, "SRCEAPPL")

		grid.setOnGetText(self.onGridGetText)
		
		self.dsBatch = self.openDataSource("dsAPIBCro")
		grid.refreshData()
		self.show()

	def onGridGetText(self, e):
		global apinv
		
		if apinv == None:
			apinv = APInvoice()
		
		if e.caption == "Entered By":
			e.value = ""
			
			cntbtch = float(self.dsBatch.get("CNTBTCH"))
			apinv.apibc.put("CNTBTCH", cntbtch)
			if apinv.apibc.read() == 0:
				# read the first document, and read the enteredby value:
				apinv.apibh.recordClear()
				apinv.apibh.browse("",1)
				if apinv.apibh.fetch() == 0:
					enteredBy = apinv.apibh.get("ENTEREDBY").strip()
					e.value = enteredBy
			
			